#pragma once

#include "ObserverTool.h"

struct RegInfo
{
	HKEY m_hKey;
	UINT m_NotifyMessage;
	TCHAR m_RegPath[MAX_PATH];
};

const int CHECK_EVENT_NUMBER = 3;
class CRegMon
{
	private :
		HWND m_hWnd ;
		HANDLE m_hThread ;
		HANDLE m_hEvent[CHECK_EVENT_NUMBER] ;
		// 0 : Notifiy Event 
		// 1 : Finish Event
		// 2 : Continue Event

		RegInfo m_RegInfo;
		IObserver* m_Impl;
		CRITICAL_SECTION *m_pCrit;
		
	protected :
		static unsigned __stdcall RegNotifyChangeProc(void *) ;
		static BOOL WaitContinueEvent(const CRegMon *);
		static BOOL WaitNotifyEvent(const CRegMon *);
	public:
		CRegMon() ;
		~CRegMon() ;
		bool Initialize(HWND, HKEY hKey, UINT notifyMessage, LPCTSTR RegPath, IObserver *pImpl) ;
		void Finalize() ;
		void Continue();
		IObserver* GetFixTool() { return m_Impl; }
} ;
